<?php

	// Dismiss Session
	PHPVC_SESSION::VAR_STOP();
	
	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
	// Check access rights This may slow down server, uncomment this if you requires an extra security
	// PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'record_po_order_list');
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_REC_PORDER_LIST_ID',
					'PARAM_REC_PORDER_LIST_REC_PORDER_ID',
					'PARAM_REC_PORDER_LIST_CAT_COMPANY_ID',
					'PARAM_REC_PORDER_LIST_CAT_PRODUCT_ID',
					'PARAM_REC_PORDER_LIST_QUANTITY_FROM',
					'PARAM_REC_PORDER_LIST_QUANTITY_TO',
					'PARAM_REC_PORDER_LIST_QUANTITY_NET_FROM',
					'PARAM_REC_PORDER_LIST_QUANTITY_NET_TO',
					'PARAM_REC_PORDER_LIST_QUANTITY_TOTAL_FROM',
					'PARAM_REC_PORDER_LIST_QUANTITY_TOTAL_TO',
					'PARAM_REC_PORDER_LIST_PRICE_PPACK_FROM',
					'PARAM_REC_PORDER_LIST_PRICE_PPACK_TO',
					'PARAM_REC_PORDER_LIST_PRICE_TOTAL_FROM',
					'PARAM_REC_PORDER_LIST_PRICE_TOTAL_TO',
					'PARAM_REC_PORDER_LIST_STATUS',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_REC_PORDER_LIST_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_PORDER_LIST_ID');
			$PARAM_REC_PORDER_LIST_REC_PORDER_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_PORDER_LIST_REC_PORDER_ID');
			$PARAM_REC_PORDER_LIST_CAT_COMPANY_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_PORDER_LIST_CAT_COMPANY_ID');
			$PARAM_REC_PORDER_LIST_CAT_PRODUCT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_PORDER_LIST_CAT_PRODUCT_ID');
			$PARAM_REC_PORDER_LIST_QUANTITY_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_LIST_QUANTITY_FROM');
			$PARAM_REC_PORDER_LIST_QUANTITY_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_LIST_QUANTITY_TO');
			$PARAM_REC_PORDER_LIST_QUANTITY_NET_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_LIST_QUANTITY_NET_FROM');
			$PARAM_REC_PORDER_LIST_QUANTITY_NET_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_LIST_QUANTITY_NET_TO');
			$PARAM_REC_PORDER_LIST_QUANTITY_TOTAL_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_LIST_QUANTITY_TOTAL_FROM');
			$PARAM_REC_PORDER_LIST_QUANTITY_TOTAL_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_LIST_QUANTITY_TOTAL_TO');
			$PARAM_REC_PORDER_LIST_PRICE_PPACK_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_LIST_PRICE_PPACK_FROM');
			$PARAM_REC_PORDER_LIST_PRICE_PPACK_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_LIST_PRICE_PPACK_TO');
			$PARAM_REC_PORDER_LIST_PRICE_TOTAL_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_LIST_PRICE_TOTAL_FROM');
			$PARAM_REC_PORDER_LIST_PRICE_TOTAL_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_PORDER_LIST_PRICE_TOTAL_TO');
			$PARAM_REC_PORDER_LIST_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_PORDER_LIST_STATUS');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'REC_PORDER_LIST_ID', 
						'REC_PORDER_LIST_REC_PORDER_ID', 
						'REC_PORDER_LIST_CAT_COMPANY_ID', 
						'REC_PORDER_LIST_CAT_PRODUCT_ID', 
						'REC_PORDER_LIST_QUANTITY', 
						'REC_PORDER_LIST_QUANTITY_NET', 
						'REC_PORDER_LIST_QUANTITY_TOTAL', 
						'REC_PORDER_LIST_PRICE_PPACK', 
						'REC_PORDER_LIST_PRICE_TOTAL', 
						'REC_PORDER_LIST_STATUS'
						, 
						'REC_PORDER_ID',		
						'REC_PORDER_CAT_COMPANY_ID',		
						'REC_PORDER_CODE',		
						'REC_PORDER_INVOICE_CODE',		
						'REC_PORDER_AMOUNT',		
						'REC_PORDER_REMARKS',		
						'REC_PORDER_DATE_EXPECT',		
						'REC_PORDER_DATE_DELIVERY',		
						'REC_PORDER_ACC_ACCOUNT_ID',		
						'REC_PORDER_DATE_REQUEST',		
						'REC_PORDER_STATUS',		
						'CAT_COMPANY_ID',		
						'CAT_COMPANY_DESCRIPTION',		
						'CAT_COMPANY_TIN',		
						'CAT_COMPANY_ADDRESS',		
						'CAT_COMPANY_MOBILE',		
						'CAT_COMPANY_PHONE',		
						'CAT_COMPANY_FAX',		
						'CAT_COMPANY_EMAIL',		
						'CAT_COMPANY_WEBSITE',		
						'CAT_COMPANY_SNS_PAGE',		
						'CAT_COMPANY_COMPANY_TYPE',		
						'CAT_COMPANY_REMARKS',		
						'CAT_COMPANY_STATUS',		
						'CAT_COMPANY_SYSTEM_GENERATED',		
						'CAT_PRODUCT_ID',		
						'CAT_PRODUCT_CAT_UOM_ID',		
						'CAT_PRODUCT_BARCODE',		
						'CAT_PRODUCT_ITEMCODE',		
						'CAT_PRODUCT_DESCRIPTION',		
						'CAT_PRODUCT_HAS_RECIPE',		
						'CAT_PRODUCT_ING_PRICE',		
						'CAT_PRODUCT_ING_NET_CONTENT',		
						'CAT_PRODUCT_MIXTURE_QTY',		
						'CAT_PRODUCT_MIXTURE_COST',		
						'CAT_PRODUCT_STATUS',		
						'CAT_PRODUCT_SYSTEM_GENERATED'		
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_RECORD_PO_ORDER_LIST::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_ID'] = $PARAM_REC_PORDER_LIST_ID;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_REC_PORDER_ID'] = $PARAM_REC_PORDER_LIST_REC_PORDER_ID;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_CAT_COMPANY_ID'] = $PARAM_REC_PORDER_LIST_CAT_COMPANY_ID;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_CAT_PRODUCT_ID'] = $PARAM_REC_PORDER_LIST_CAT_PRODUCT_ID;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_QUANTITY_FROM'] = $PARAM_REC_PORDER_LIST_QUANTITY_FROM;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_QUANTITY_TO'] = $PARAM_REC_PORDER_LIST_QUANTITY_TO;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_QUANTITY_NET_FROM'] = $PARAM_REC_PORDER_LIST_QUANTITY_NET_FROM;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_QUANTITY_NET_TO'] = $PARAM_REC_PORDER_LIST_QUANTITY_NET_TO;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_QUANTITY_TOTAL_FROM'] = $PARAM_REC_PORDER_LIST_QUANTITY_TOTAL_FROM;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_QUANTITY_TOTAL_TO'] = $PARAM_REC_PORDER_LIST_QUANTITY_TOTAL_TO;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_PRICE_PPACK_FROM'] = $PARAM_REC_PORDER_LIST_PRICE_PPACK_FROM;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_PRICE_PPACK_TO'] = $PARAM_REC_PORDER_LIST_PRICE_PPACK_TO;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_PRICE_TOTAL_FROM'] = $PARAM_REC_PORDER_LIST_PRICE_TOTAL_FROM;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_PRICE_TOTAL_TO'] = $PARAM_REC_PORDER_LIST_PRICE_TOTAL_TO;
			$GET_MAP_ARRAY['PARAM_REC_PORDER_LIST_STATUS'] = $PARAM_REC_PORDER_LIST_STATUS;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_RECORD_PO_ORDER_LIST::CUS_GET_LITE_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>